OpenTTD Source: Layouter Class Reference

OpenTTD Source 15.0-RC2

Data Structures | Public Member Functions | Static Public Member Functions | Private Types | Static Private Member Functions | Private Attributes | Static Private Attributes | Friends
Layouter Class Reference

The layouter performs all the layout work. More...

`#include <gfx_layout.h>`

Inheritance diagram for Layouter:

## Data Structures
struct | LineCacheEqualTo
struct | LineCacheHash
struct | LineCacheItem
| Item in the linecache. More...
struct | LineCacheKey
| Key into the linecache. More...
struct | LineCacheQuery

## Public Member Functions
| Layouter (std::string_view str, int maxw=INT32_MAX, FontSize fontsize=FS_NORMAL)
| Create a new layouter.
Dimension | GetBounds ()
| Get the boundaries of this paragraph.
ParagraphLayouter::Position | GetCharPosition (std::string_view::const_iterator ch) const
| Get the position of a character in the layout.
ptrdiff_t | GetCharAtPosition (int x, size_t line_index) const
| Get the character that is at a pixel position in the first line of the layouted text.

## Static Public Member Functions
static Font * | GetFont (FontSize size, TextColour colour)
| Get a static font instance.
static void | Initialize ()
| Perform initialization of layout engine.
static void | ResetFontCache (FontSize size)
| Reset cached font information.
static void | ResetLineCache ()
| Clear line cache.

## Private Types
using | LineCache = LRUCache< LineCacheKey, LineCacheItem, LineCacheHash, LineCacheEqualTo >
using | FontColourMap = std::map< TextColour, std::unique_ptr< Font > >

## Static Private Member Functions
static LineCacheItem & | GetCachedParagraphLayout (std::string_view str, const FontState &state)
| Get reference to cache item.

## Private Attributes
std::string_view | string
| Pointer to the original string.

## Static Private Attributes
static std::unique_ptr< LineCache > | linecache
| Cache of ParagraphLayout lines.
static FontColourMap | fonts [FS_END]
| Cache of Font instances.

## Friends
struct | std::hash< Layouter::LineCacheQuery >

## Detailed Description

The layouter performs all the layout work.

It also accounts for the memory allocations and frees.

Definition at line 160 of file gfx_layout.h.

## Member Typedef Documentation

## ◆ FontColourMap

using Layouter::FontColourMap = std::map<TextColour, std::unique_ptr<Font> >
| private

Definition at line 208 of file gfx_layout.h.

## ◆ LineCache

using Layouter::LineCache = LRUCache<LineCacheKey, LineCacheItem, LineCacheHash, LineCacheEqualTo>
| private

Definition at line 203 of file gfx_layout.h.

## Constructor & Destructor Documentation

## ◆ Layouter()

Layouter::Layouter | ( | std::string_view | str,
|  | int | maxw = `INT32_MAX`,
|  | FontSize | fontsize = `FS_NORMAL`
| ) |  |

Create a new layouter.

Parameters

  str | The string to create the layout for.
  maxw | The maximum width.
  fontsize | The size of font to use.

Definition at line 129 of file gfx_layout.cpp.

References Layouter::LineCacheItem::cached_layout, Layouter::LineCacheItem::cached_width, GetCachedParagraphLayout(), Layouter::LineCacheItem::layout, and Layouter::LineCacheItem::state_after.

## Member Function Documentation

## ◆ GetBounds()

Dimension Layouter::GetBounds | ( |  | ) |

Get the boundaries of this paragraph.

Returns
  The boundaries.

Definition at line 208 of file gfx_layout.cpp.

Referenced by DrawStringMultiLine(), GetStringBoundingBox(), and GetStringHeight().

## ◆ GetCachedParagraphLayout()

Layouter::LineCacheItem & Layouter::GetCachedParagraphLayout | ( | std::string_view | str,
|  | const FontState & | state
| ) |  |
| staticprivate

Get reference to cache item.

If the item does not exist yet, it is default constructed.

Parameters

  str | Source string of the line (including colour and font size codes).
  state | State of the font at the beginning of the line.

Returns
  Reference to cache item.

Definition at line 389 of file gfx_layout.cpp.

References linecache, Layouter::LineCacheKey::state_before, and Layouter::LineCacheKey::str.

Referenced by Layouter().

## ◆ GetCharAtPosition()

ptrdiff_t Layouter::GetCharAtPosition | ( | int | x,
|  | size_t | line_index
| ) |  | const

Get the character that is at a pixel position in the first line of the layouted text.

Parameters

  x | Position in the string.
  line_index | Which line of the layout to search

Returns
  String offset of the position (bytes) or -1 if no character is at the position.

Definition at line 303 of file gfx_layout.cpp.

References IsConsumedFormattingCode(), and IsInsideMM().

Referenced by GetCharAtPosition().

## ◆ GetCharPosition()

ParagraphLayouter::Position Layouter::GetCharPosition | ( | std::string_view::const_iterator | ch | ) | const

Get the position of a character in the layout.

Parameters

  ch | Character to get the position of. Must be an iterator of the string passed to the constructor.

Returns
  Upper left corner of the character relative to the start of the string.

Note
  Will only work right for single-line strings.

Definition at line 237 of file gfx_layout.cpp.

References _current_text_dir, Utf8View::GetIterAtByte(), IsConsumedFormattingCode(), and TD_LTR.

Referenced by GetCharPosInString().

## ◆ GetFont()

Font * Layouter::GetFont | ( | FontSize | size,
|  | TextColour | colour
| ) |  |
| static

Get a static font instance.

Definition at line 344 of file gfx_layout.cpp.

References fonts.

Referenced by GetLayouter().

## ◆ Initialize()

void Layouter::Initialize | ( |  | ) |
| static

Perform initialization of layout engine.

Definition at line 356 of file gfx_layout.cpp.

References ICUParagraphLayoutFactory::InitializeLayouter().

Referenced by ReadLanguagePack().

## ◆ ResetFontCache()

void Layouter::ResetFontCache | ( | FontSize | size | ) |
| static

Reset cached font information.

Parameters

  size | Font size to reset.

Definition at line 367 of file gfx_layout.cpp.

References fonts, MacOSResetScriptCache(), and ResetLineCache().

Referenced by SpriteFontCache::ClearFontCache(), TrueTypeFontCache::ClearFontCache(), and FontCache::LoadFontCaches().

## ◆ ResetLineCache()

void Layouter::ResetLineCache | ( |  | ) |
| static

Clear line cache.

Definition at line 412 of file gfx_layout.cpp.

References linecache.

Referenced by ResetFontCache().

## Friends And Related Symbol Documentation

## ◆ std::hash< Layouter::LineCacheQuery >

friend struct std::hash< Layouter::LineCacheQuery >
| friend

Definition at line 161 of file gfx_layout.h.

## Field Documentation

## ◆ fonts

Layouter::FontColourMap Layouter::fonts
| staticprivate

Cache of Font instances.

Definition at line 209 of file gfx_layout.h.

Referenced by GetFont(), and ResetFontCache().

## ◆ linecache

std::unique_ptr< Layouter::LineCache > Layouter::linecache
| staticprivate

Cache of ParagraphLayout lines.

Definition at line 204 of file gfx_layout.h.

Referenced by GetCachedParagraphLayout(), and ResetLineCache().

## ◆ string

std::string_view Layouter::string
| private

Pointer to the original string.

Definition at line 161 of file gfx_layout.h.

The documentation for this class was generated from the following files:

- src/gfx_layout.h
- src/gfx_layout.cpp